﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Persistence;

namespace doLogic
{
    public class ManagerLocations : PersistentList<ManagerLocation>
    {
        public Manager Manager { get; protected set; }

        public static ManagerLocations For(int managerID)
        {
            if (managerID < 1)
                throw new ApplicationException("ManagerID is required.");

            using (Connection cn = Database.Open())
            {
                ManagerLocations list = new ManagerLocations();
                list.Load("ForManager", new { ManagerID = managerID }, cn);

                list.Manager = Manager.Load(managerID, cn);

                foreach (ManagerLocation ml in list)
                {
                    ml.Manager = list.Manager;
                    ml.LoadLocation(cn);
                }
                return list;
            }
        }
    }

    [Persistable("Manager_Locations", "ID", false)]
    public class ManagerLocation : LocationManager
    {
        internal void LoadLocation(Connection cn)
        {
            this.Location = Location.Load(this.LocationID, cn);
        }
    }
}
