﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Persistence;

namespace doLogic
{
	public class Roles : PersistentList<Role>
	{
		private static Roles _Roles = null;
		public static Roles All
		{
			get
			{
				if (_Roles == null)
					_Roles = new Roles(true);
				return _Roles;
			}
		}

		internal static Roles ForUser(User user)
		{
			Roles list = new Roles(false);
			foreach (Role r in new Roles(user))
				list.Add(Roles.All.ItemById(r.ID));
			return list;
		}

		private Roles(User user)
		{
			this.UserID = user.ID;
			this.Load("ForUser");
		}

		private Roles(bool fill)
		{
			if (fill)
				this.Load();
		}

		public int UserID { get; set; }
	}

	[Persistable("secRole", "ID", false)]
	public class Role
	{
		public int ID { get; set; }
		public string Name { get; set; }
		public bool IsInternal { get; set; }
	}
}
